#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    size_t number_count, bin_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);
    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++){
        cin >> numbers[i];
    }
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<size_t> bins(bin_count);

    double min = numbers[0];
    double max = numbers[0];

    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }

    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    size_t max_count = 0;
    for (size_t i = 0; i < bin_count; i++){
        size_t Count = bins[i];
        if (max_count < Count){
            max_count = Count;
        }
    }

    if (max_count <= MAX_ASTERISK){
        for (size_t i = 0; i < bin_count; i++){
            size_t Count = bins[i];
            if (Count < 100){
                cout << " ";
            }
            if (Count < 10){
                cout << " ";
            }
            cout << Count << "|";
            for (size_t j = 0; j < Count; j++){
                cout << "*";
            }
            cout << "\n";
        }
    }
    else{
        for (size_t i = 0; i < bin_count; i++){
            size_t Count = bins[i];
            size_t height = 76 * (static_cast<double>(Count) / max_count);
            if (Count < 100){
                cout << " ";
            }
            if (Count < 10){
                cout << " ";
            }
            cout << Count << "|";
            for (size_t j = 0; j < height; j++){
                cout << "*";
            }
            cout << "\n";
        }
    }
    return 0;
}
